import QtQuick 2.15
import QtQuick.Controls 2.0

import Dcchat 1.0
Rectangle {
    id: _view
    default property alias _data: contain.data
    signal closeView()

    ChatStack {
        id: stack
    }
    Item {
        // dung item boi vi co truong hop se gi de thuoc 1 so thuoc tinh nhu
        // color ....
        anchors.fill: parent
        id: contain
        visible: true
    }
    Rectangle {
        id: virtual
        visible : false
        color: "gray"
        opacity: 0.50
        anchors.fill: parent
    }
    Loader {
        id: load
        z:1
        active: false
        anchors.centerIn: parent
    }
    function setView(component ,  property)
    {

        if(property !== undefined)
        {
            load.setSource(component , property )
            stack.pushMap(component , property )
        }
        else
            load.setSource(component)
    }
    function showView(component , property ){

        // push another source
        if(load.source != "")
        {
            stack.pushView(load.source)
            load.source=""
            Qt.callLater(setView , component ,  property )
        }
        else
        {
            setView(component , property )
        }
        virtual.visible = true
        load.active = true
    }

    Connections {
        target: _view
        function onCloseView()
        {
            // clear old data
            load.source = ""
            stack.popMap(load.source );
            // pop stack data
            var ssource = stack.popView()
            var data = stack.popMap(ssource);
            if(ssource !== "")
            {
                load.active = false
                Qt.callLater(showView,ssource,data);
            } else {
                virtual.visible = false
                load.active = false
            }
        }
    }
}
