import QtQuick 2.15
import QtQuick.Controls 2.0
import QtQuick.Layouts 1.3
import Dcchat 1.0
import DCStyle 1.0

Rectangle {
    width: 400
    height: 640
    radius: 6
    ContactModel {
        id : model
    }
    ColumnLayout {
        x:5
        y:5
        width: parent.width - 10
        height: parent.height -10
        RowLayout {
            z:2
            Layout.fillWidth: true
            implicitHeight: tf.height
            TextField {
                id: tf
                Layout.fillWidth: true
                placeholderText :qsTr("Enter new email")
            }

            Button {
                height: parent.height
                text: qsTr("Chat")
                onClicked: {
                    var cid = model.newChatWithEmail(tf.text)
                    // chatlist.chatlistview.idChange(cid)
                    chatlist.closeView()
                }
            }
        }


        ListView {
            id: view
            width: parent.width
            Layout.fillHeight: true
            model: model
            spacing: 4
            delegate: Rectangle {
                required property string $name
                required property int $id
                width: view.width
                height: 50
                MouseArea {
                    anchors.fill: parent
                    onClicked: {
                        var cid = model.chatWithId($id)
                        chatlist.chatlistview.idChange(cid)
                        chatlist.closeView()
                    }
                }

                RowLayout {
                    anchors.fill: parent
                    Layout.fillWidth:true
                    ContactIcon {
                        id:ct
                        $text: $name
                        height: parent.height
                        Layout.fillWidth:true
                    }
                    Button {
                        id:test
                        text: "x"
                        onClicked: {
                            var pro = { $name:$name , $id:$id }
                            //
                            chatlist.showView("qrc:/qml/chat/contact/RmContact.qml",pro)
                        }
                    }
                }

            }

        }
        Item {
            Layout.fillWidth: true
            implicitHeight: btn.implicitHeight
            Button {
                anchors.left: parent.left
                text: qsTr("New Group")
                onClicked: {
                    chatlist.showView("qrc:/qml/chat/contact/CreateGroup.qml")
                }
            }
            Button {
                id : btn
                anchors.right: parent.right
                text: qsTr("Close")
                onClicked: {
                    chatlist.closeView()
                }
            }
        }
    }
}
