import QtQuick 2.15
import QtQuick.Controls 2.0
import QtQuick.Layouts 1.3
import Dcchat 1.0
import DCStyle 1.0

Rectangle {
    width: 400
    height: 640
    radius: 5
    ContactCheckListModel {
        id:lmodel
    }
    ColumnLayout {
        x:5
        y:5
        width: parent.width -10
        height: parent.height - 10
        spacing: 5
        Rectangle {
            Layout.fillWidth: true
            height: row.height
            z:1
            RowLayout {
                id: row
                anchors.fill: parent
                height: tf.height
                Text {
                    height: parent.height
                    text: qsTr("Group")
                }
                TextField {
                    id: tf
                    Layout.fillWidth: true
                }
                CheckBox {
                    id: sercure
                    text: qsTr("Sercure")
                }
            }
        }
        ListView {
            id:view
            Layout.fillWidth: true
            Layout.fillHeight: true
            spacing: 2
            model : lmodel
            delegate: Rectangle {
                required property string $name
                required property int $id
                required property bool $check
                required property int index
                width: view.width
                height: 40
                RowLayout {
                    anchors.fill: parent
                    ContactIcon {
                        Layout.fillWidth: true
                        height: parent.height
                        $text: $name
                    }
                    CheckBox {
                        id: _checkbox
                        checkable: ! sercure.checkState
                        checked: $check
                        onCheckStateChanged: {
                            // console.debug("index is"+index)
                            lmodel.setData(lmodel.index(index,0),checkState,lmodel.editRole())
                        }
                    }
                }

            }
        }
        Text {
            Layout.fillWidth: true
            visible: sercure.checkState
            text: qsTr("If you create sercure chat , memeber only invite to chat with qrcode")
            wrapMode: Text.WordWrap
        }
        RowLayout {
            Layout.fillWidth: true
            height: 30
            Button {
                Layout.fillWidth: true
                height: parent.height
                text: qsTr("Exit")
                onClicked: {
                    chatlist.closeView()
                }
            }
            Button {
                Layout.fillWidth: true
                height: parent.height
                text: qsTr("Create")
                onClicked: {
                    lmodel.createChat(tf.text)
                    chatlist.closeView()
                }
            }
        }
    }
}
