import QtQuick 2.15
import QtQuick.Layouts 1.0

import DCStyle 1.0
Item{

    // mode data
    id: _mess
    required property bool $local
    required property bool $isInfo
    required property string $text
    required property string $user
    required property date $date
    // for show data
    required property int $isProtect
    required property string $status


    height: rec.height
    Layout.fillWidth: true

    /* bounday border*/
    Rectangle {
        id:rec
        // chang size of x
        radius: 5
        width: show.width + 20
        height: show.height + 20
        color: $local ? MessStyle.mess.incoming.color : MessStyle.mess.outgoing.color
        x : getX()
        ColumnLayout {
            x:10
            y:10
            id : show
            Text {
                id: header
                color: "green"
                Layout.fillWidth: true
                text : $user
                visible: model.isGroup() && (! $local) && (! $isInfo)
            }
            Text {

                id : text
                /* limit wigth of text */
                Layout.maximumWidth: _mess.width - MessStyle.margin.maxsize
                // fix no texxt display
                text: $text
                // text: $text
                wrapMode: Text.WordWrap
                onLinkActivated:
                {
                    var obj = { qrcode:link , stext:$text }
                    mess_area.showView("qrc:/qml/chat/popup/JoinChatPopup.qml",obj)
                }
            }
            RowLayout {
                Layout.fillWidth: true
                visible: ! $isInfo
                Item {
                     Layout.fillWidth: true
                }
                Text {
                    id: lock
                    text: String.fromCodePoint(0x1F512)
                    visible: $isProtect
                }

                Text {
                    id: po
                    text: $status
                    visible: $local
                }
            }
        }
    }
    function getX()
    {
        if($isInfo){
            return  ( _mess.width - rec.width )/2
        } else {
            return  $local ? _mess.width - rec.width - MessStyle.margin.padding : MessStyle.margin.padding
        }
    }
}
