import QtQuick 2.15
import QtQuick.Controls 2.3
import QtQuick.Layouts 1.3
import Dcchat 1.0

import DCStyle 1.0
import "MessPopup.js" as MP
Rectangle {

    width: 400
    color: "white"
    height: 500
    radius: 5

    required property int chat_id
    ChatContact {
        id : model
        chatId: chat_id
    }
    Rectangle {
        id: contact
        x:10
        y:10
        width: parent.width - 20
        height: parent.height - 20

        ColumnLayout {
            anchors.fill: parent
            spacing: 0
            RowLayout {
                z:2
                width: parent.width
                height: 30
                Text {
                    text: mess_area.model.isGroup() ? qsTr("Group") : qsTr("Contact")
                    Layout.fillWidth: true
                }
                Button {
                    width: 20
                    text: qsTr("edit")
                    visible: false
                }
                Button {
                    width: 20
                    text: qsTr("Close")
                    onClicked: {
                        mess_area.closeView();
                    }
                }
            }
            Rectangle {
                Layout.fillWidth: true
                height: row.height
                color: "white"
                z:2
                RowLayout {
                    id :row

                    spacing: 10

                    TextIcon {
                        dptext: model.chatName
                        size:50
                    }
                    Text {
                        text: model.chatName
                        height: 50
                        font.pixelSize: 50 / 2
                    }
                }
            }
            Rectangle {
                height:  30
                color: "lightgray"
                Layout.fillWidth: true
                z:2
                visible: mess_area.model.isGroup()
                Text{
                    anchors.fill: parent
                    text: qsTr("Number in Group: ")+model.nuser
                    verticalAlignment: Text.AlignVCenter
                }
            }
            Rectangle {
                height:  50
                Layout.fillWidth: true
                z:1
                visible: mess_area.model.isGroup() && mess_area.model.active
                RowLayout {
                    anchors.fill: parent
                    TextIcon {
                        size: parent.height
                        dptext: "+"
                        color:  "gray"
                    }
                    Text {
                        Layout.fillWidth: true
                        height: parent.height
                        verticalAlignment: Text.AlignVCenter
                        text:  qsTr("Add Member")
                    }

                }
                MouseArea {
                    anchors.fill: parent
                    onClicked: {
                        var dir = MP.build_dir("GroupContactAdd.qml")
                        mess_area.showView(dir)
                    }
                }
            }
            ListView {
                id: view
                Layout.fillWidth: true
                height: 250
                model: model
                delegate: ContactItem {
                    chat_id: model.chatId
                    width: contact.width
                }
            }
        }
    }


}
