import QtQuick 2.15
import QtQuick.Controls 2.3
import QtQuick.Layouts 1.3
import DCStyle 1.0

import Dcchat 1.0
Rectangle {
    width: 400
    height: 640
    ContactCheckListModel {
        id:model
        chatId: mess_area.chat_id
    }
    ColumnLayout {
        x:5
        y:5
        width: parent.width -10
        height: parent.height - 10
        spacing: 5
        Text {
            Layout.fillWidth: true
            text:qsTr("Group")
        }
        Rectangle {
            Layout.fillWidth: true
            height: icon.height
            z:1

            ContactIcon {
                id: icon
                $text : mess_area.model.chatName()
                height: 40
                width: parent.width
            }
        }
        Rectangle {
            Layout.fillWidth: true
            color: "gray"
            height: 3
            z:1
        }
        ListView {
            id:view
            Layout.fillWidth: true
            Layout.fillHeight: true
            spacing: 2
            model : model
            delegate: Rectangle {
                required property string $name
                required property int $id
                required property bool $check
                required property int index
                width: view.width
                height: 40
                RowLayout {
                    anchors.fill: parent
                    ContactIcon {
                        Layout.fillWidth: true
                        height: parent.height
                        $text: $name
                    }
                    CheckBox {
                        id: _checkbox
                        checked: $check
                        onCheckStateChanged: {
                            // console.debug("index is"+index)
                            model.setData(model.index(index,0),checkState,model.editRole())
                        }
                    }
                }

            }
        }

        RowLayout {
            Layout.fillWidth: true
            height: 30
            Button {
                Layout.fillWidth: true
                height: parent.height
                text: qsTr("Exit")
                onClicked: {
                    mess_area.closeView()
                }
            }
            Button {
                Layout.fillWidth: true
                height: parent.height
                text: qsTr("Add")
                onClicked: {
                    // lmodel.createChat(tf.text)
                    model.addContactToChat(mess_area.chat_id)
                    mess_area.closeView()
                }
            }
        }
    }
}
