#include "acc.h"
#include "task.h"
#include <QTextStream>
#include <deltachat/deltacpp.h>

using namespace dc;
Acc::Acc(Task* parent)
    : QObject { parent }
    , ts(stdout)
{
    connect(parent, &Task::processInput, this, &Acc::proccsesInput);
}

void Acc::showUser()
{
    auto list = Account::getInstance()->getAll();
    ts << "Show user" << Qt::endl;
    if (list.size() == 0) {
        ts << "\tNo aviable user" << Qt::endl;
        return;
    }
    for (auto acc : list) {
        auto ctx = Account::getInstance()->getAccount(acc);
        QString info = ctx->getConfig("addr");
        ts << "\tId:" << acc << "\tUser: " << info << Qt::endl;
    }
    ts << "\n\tCurent user: " << Account::getInstance()->getSelectedAccount()->getConfig("addr")
       << Qt::endl;
}

void Acc::addUser(const QStringList& qm)
{
    if (qm.size() < 4) {
        ts << "Error:Not enought variable" << Qt::endl;
    }
    QString mail = qm.at(2);
    QString pass = qm.at(3);

    // new acc
    auto manager = Account::getInstance();
    auto id = manager->addAcount();
    auto ctx = manager->getAccount(id);

    ctx->setConfig("addr", mail);
    ctx->setConfig("mail_pw", pass);

    auto list = mail.split("@");
    QString ser = "mail." + list.at(1);
    // config imap
    ctx->setConfig("mail_server", ser);
    ctx->setConfig("mail_port", "143");
    // smtp config
    ctx->setConfig("send_server", ser);
    ctx->setConfig("send_port", "465");

    // accep invalid cerrt
    ctx->setConfig("imap_certificate_checks", QString::number(DC_CERTCK_ACCEPT_INVALID));
    ctx->setConfig("smtp_certificate_checks", QString::number(DC_CERTCK_ACCEPT_INVALID));
    ctx->configure();
    ts << "\tUser is add" << Qt::endl;
}
void Acc::rmUser(const QStringList& qm)
{
    QTextStream ts(stdout);
    if (qm.size() < 3)
        return;
    uint32_t id = qm.at(2).toInt();
    Account::getInstance()->removeAccount(id);
    ts << "\tUser is removed" << Qt::endl;
}
void Acc::showHelp()
{
    ts << "User Command" << Qt::endl;
    ts << "\tuser show : show all user\n";
    ts << "\tuser detail <id> : show full detail for user\n";
    ts << "\tuser add <mail addr> <mail pass>: ADD USER\n";
    ts << "\tuser use <id>: select it to default account\n";
    ts << "\tuser rm <id>: remove user";
    ts << Qt::endl;
}

void Acc::useUser(const QStringList& qm)
{
    if (qm.size() < 3)
        return;
    uint32_t id = qm.at(2).toInt();
    Account::getInstance()->setSelectAccount(id);
    ts << "\tDefalt user set to id :" << id << Qt::endl;
}

void Acc::showQr(const QString& id)
{
    int cid = id.toInt();
    auto ctx = Account::getInstance()->getAccount(cid);
    ts << "\tQrcode is: " << ctx->getSecurejoinQr(0) << Qt::endl;
}
void Acc::proccsesInput(const QStringList& qm)
{
    auto cmd = qm.at(0);
    if (cmd == "help") {
        showHelp();
        return;
    } else if (cmd != "user")
        return;

    cmd = qm.at(1);
    if (cmd == "show")
        showUser();
    else if (cmd == "add")
        addUser(qm);
    else if (cmd == "rm")
        rmUser(qm);
    else if (cmd == "use")
        useUser(qm);
    else if (cmd == "detail" && qm.size() == 3)
        showQr(qm.at(2));
}
