#include "contactui.h"
#include "task.h"
#include <deltachat/deltacpp.h>
ContactUi::ContactUi(Task* parent)
    : QObject { parent }
    , ts(stdout)
{
    connect(parent, &Task::processInput, this, &ContactUi::proccsesInput);
}

void ContactUi::proccsesInput(const QStringList& qm)
{
    if (qm.at(0) == "help") {
        showHelp();
        return;
    }
    if (qm.at(0) != "contact" || qm.size() < 2) {
        return;
    }
    QString qs = qm.at(1);
    if (qs == "show") {
        listContact();
    } else if (qs == "rm" && qm.size() == 3) {
        removeContact(qm.at(2));
    } else if (qs == "add" && qm.size() == 4) {
        addContact(qm.at(2), qm.at(3));
    }
}

void ContactUi::showHelp()
{
    ts << "Contact comad:\n";
    ts << "\tcontact show : show all contact\n";
    ts << "\tcontact add <name> <mail_addr> : add contact\n";
    ts << "\tcontact rm <id> : remove contact with id";
    ts << Qt::endl;
}

void ContactUi::listContact()
{
    auto ctx = dc::Account::getInstance()->getSelectedAccount();
    auto list = ctx->getContacts(0, nullptr);
    for (auto id : list) {
        auto contact = ctx->getContact(id);
        ts << "\tId:" << id << "\taddr:" << contact->getAddr() << Qt::endl;
    }
}

void ContactUi::addContact(const QString& name, const QString& addr)
{
    auto ctx = dc::Account::getInstance()->getSelectedAccount();
    ctx->createContact(name, addr);
    ts << "\tContact is added" << Qt::endl;
}

void ContactUi::removeContact(const QString& id)
{
    uint32_t cid = id.toInt();
    auto ctx = dc::Account::getInstance()->getSelectedAccount();
    ctx->deleteContact(cid);
}
