#include "task.h"
#include <QDebug>
#include <QTextStream>

Task::Task()
{
    isrun = true;
    connect(this, &Task::processInput, this, &Task::check);
}
static QStringList praseLine(const QString& line)
{
    QStringList ret;
    QString data = "";
    bool quote = false;
    for (int i = 0; i < line.count(); i++) {
        auto c = line.at(i);
        if (quote) {
            if (c == '"') {
                quote = false;
                if (data != "") {
                    ret.append(data);
                    data = "";
                }
            } else {
                data.append(c);
            }
        } else {
            if (c == '"') {
                quote = true;
            } else {
                if (c == ' ') {
                    if (data != "") {
                        ret.append(data);
                        data = "";
                    }
                } else {
                    data.append(c);
                }
            }
        }
    }
    if (data != "") {
        ret.append(data);
    }
    return ret;
}
void Task::run()
{
    QTextStream stream(stdin);
    QString line = "";

    fd_set rfds;
    struct timeval tv;
    int retval;
    tv.tv_sec = 1; // Timeout: 1 seconds
    tv.tv_usec = 0;

    do {
        FD_ZERO(&rfds);
        FD_SET(fileno(stdin), &rfds);
        retval = select(fileno(stdin) + 1, &rfds, NULL, NULL, &tv);

        if (retval) {
            line = stream.readLine();
            if (line != "") {
                QStringList qlist = praseLine(line);
                emit processInput(qlist);
            }
        }

    } while (isrun);
    emit finish();
}

void Task::check(const QStringList& qm)
{
    if (qm.at(0) == "q") {
        this->isrun = 0;
    } else if (qm.at(0) == "help") {
        QTextStream ts(stdout);
        ts << "\tq: quit application" << Qt::endl;
    }
}

void Task::disablerun()
{
    isrun = false;
}
