#include "chat.h"

using namespace dc;

Chat::Chat(dc_chat_t *chat)
    : QObject{nullptr}
    , m_chat{chat}
{}

Chat::~Chat()
{
    dc_chat_unref(m_chat);
}

uint32_t Chat::getId()
{
    return dc_chat_get_id(m_chat);
}

int Chat::getType()
{
    return dc_chat_get_type(m_chat);
}

QString Chat::getName()
{
    char *name = dc_chat_get_name(m_chat);
    QString result{name};
    dc_str_unref(name);
    return result;
}

QString Chat::getProfileImage()
{
    char *profileImage = dc_chat_get_profile_image(m_chat);
    QString result{profileImage};
    dc_str_unref(profileImage);
    return result;
}

bool Chat::isContactRequest()
{
    return dc_chat_is_contact_request(m_chat);
}

bool Chat::canSend()
{
    return dc_chat_can_send(m_chat);
}

bool Chat::isMuted()
{
    return dc_chat_is_muted(m_chat);
}

int Chat::getVisibility()
{
    return dc_chat_get_visibility(m_chat);
}

bool Chat::isProtected()
{
    return dc_chat_is_protected(m_chat);
}

bool Chat::isProtectionBroken()
{
    return dc_chat_is_protection_broken(m_chat);
}
