#ifndef CHAT_H
#define CHAT_H

#include <QObject>
#include <deltachat.h>

namespace dc {
class Chat : public QObject
{
    Q_OBJECT
public:
    explicit Chat(dc_chat_t *chat);
    ~Chat();

    uint32_t getId();
    int getType();
    QString getName();
    QString getProfileImage();
    bool isContactRequest();
    bool canSend();
    bool isMuted();
    int getVisibility();

    bool isProtected();

    bool isProtectionBroken();

private:
    dc_chat_t *m_chat{nullptr};
};
} // namespace dc

#endif // CHAT_H
