#include "chatlist.h"
#include "lot.h"

namespace dc {

Chatlist::Chatlist(dc_chatlist_t *chatlist)
    : m_chatlist{chatlist}
{}

Chatlist::~Chatlist()
{
    dc_chatlist_unref(m_chatlist);
}

size_t Chatlist::getChatCount() const
{
    return dc_chatlist_get_cnt(m_chatlist);
}

uint32_t Chatlist::getChatId(size_t index) const
{
    return dc_chatlist_get_chat_id(m_chatlist, index);
}

uint32_t Chatlist::getMsgId(size_t index) const
{
    return dc_chatlist_get_msg_id(m_chatlist, index);
}

std::shared_ptr<Lot> Chatlist::getSummary(size_t index) const
{
    auto lot = new Lot(dc_chatlist_get_summary(m_chatlist, index, NULL));
    auto ret = std::shared_ptr<Lot>(lot);
    return ret;
}

} // namespace dc
