#include "contact.h"

namespace dc {
Contact::Contact(dc_contact_t *contact)
    : QObject{nullptr}
    , m_contact{contact}
{}

Contact::~Contact()
{
    dc_contact_unref(m_contact);
}

uint32_t Contact::getId()
{
    return dc_contact_get_id(m_contact);
}

QString Contact::getAddr()
{
    char *addr = dc_contact_get_addr(m_contact);
    QString result{addr};
    dc_str_unref(addr);
    return result;
}

QString Contact::getName()
{
    char *name = dc_contact_get_name(m_contact);
    QString result{name};
    dc_str_unref(name);
    return result;
}

QString Contact::getDisplayName()
{
    char *display_name = dc_contact_get_display_name(m_contact);
    QString result{display_name};
    dc_str_unref(display_name);
    return result;
}

QString Contact::getProfileImage()
{
    char *profileImage = dc_contact_get_profile_image(m_contact);
    QString result{profileImage};
    dc_str_unref(profileImage);
    return result;
}

} // namespace dc
