#include "event.h"
#include <QDebug>
namespace dc {

Event::Event(dc_event_t *event)
    : m_event{event}
{}

Event::~Event()
{
    dc_event_unref(m_event);
}

int Event::getId()
{
    return dc_event_get_id(m_event);
}

int Event::getData1Int()
{
    return dc_event_get_data1_int(m_event);
}

int Event::getData2Int()
{
    return dc_event_get_data2_int(m_event);
}

QString Event::getData2Str()
{
    char *data2 = dc_event_get_data2_str(m_event);
    QString result{data2};
    dc_str_unref(data2);
    return result;
}

uint32_t Event::getAccountId()
{
    return dc_event_get_account_id(m_event);
}

} // namespace dc
