#include "eventemitter.h"
#include "event.h"
namespace dc {

EventEmitter::EventEmitter(dc_event_emitter_t *emiter)
    : m_emiter{emiter}
{}

EventEmitter::~EventEmitter()
{
    dc_event_emitter_unref(m_emiter);
}

void EventEmitter::run()
{
    dc_event_t *evt = nullptr;
    while ((evt = dc_get_next_event(m_emiter)) != nullptr) {
        auto e = QSharedPointer<Event>(new Event(evt));
        emit gotEvent(e);
    }
}
} // namespace dc
