#ifndef MESSAGE_H
#define MESSAGE_H

#include <QDateTime>
#include <QObject>
#include <deltachat.h>
#include <memory>

namespace dc {

class Lot;
class Message : public QObject {
    Q_OBJECT
private:
    dc_msg_t* m_message;

public:
    explicit Message(dc_msg_t* m_message);
    ~Message();

    // function
    uint32_t getId();
    uint32_t getFromId();
    uint32_t getChatId();
    int getViewtype();
    int getState();
    QDateTime getTimestamp();
    //  int64_t getReceivedTimestamp();
    //  int64_t getSortTimestamp();
    bool saveAttach(QString);
    void setText(QString);

    QString getText();
    QString getSubject();
    void setSubject(QString sub);
    QString getFile();
    QString getFilename();
    QString getFilemime();
    // uint64_t getFilebytes();
    int getWidth();
    int getHeight();
    // int getDuration();
    bool getShowPadlock();
    bool getIsBot();
    // uint32_t getEphemeralTimer();
    // int64_t getEphemeralTimestamp();
    //... getsummary ...
    QString getOverrideSenderName();
    // hasDeviatingTimestamp
    // hasLocation
    // isSent
    // isStarred
    // isForwarded
    bool isInfo();
    QString getError();
    bool hasHtml();
    // isIncreation
    // isSetupmessage
    QString getQuotedText();
    std::shared_ptr<Message> getQuotedMessage();

    int getInfoType();

    //
    friend class Context;
};
} // namespace dc

#endif // MESSAGE_H
