#include <QDebug>
#include <QFile>
#include <QGuiApplication>
#include <QObject>
#include <QQmlApplicationEngine>
#include <QTextStream>
#include <app/app.h>
#include <model/chat/chatcore.h>

using namespace dc;
static void init(Task* task)
{
    Acc* m_acc = new Acc(task);
    ContactUi* up = new ContactUi(task);
    ChatUi* ui = new ChatUi(task);
    (void)m_acc;
    (void)up;
    (void)ui;
}
int main(int argc, char* argv[])
{
    QGuiApplication app(argc, argv);
    ChatCore::init();
    QQmlApplicationEngine engine;
    engine.addImportPath(":/qml");
    engine.load(QUrl(QLatin1String("qrc:/qml/main.qml")));
    if (engine.rootObjects().isEmpty())
        return -1;

    qDebug() << "start amneiht chat";
    MsgShow msg;
    auto acc = Account::getInstance();
    QObject::connect(acc.get(), &Account::incomingMessage, &msg, &MsgShow::onIncomingMessage);

    Task* task = new Task();
    init(task);
    QObject::connect(task, &Task::finish, &app, &QGuiApplication::quit);
    task->start();
    app.exec();
    ChatCore::close();
    task->disablerun();
    task->wait();
    delete task;
}
