#include "chatcore.h"
#include "chatlistmodel.h"
#include "chatproxymodel.h"
#include "chatroommodel.h"
#include "contact/chatcontact.h"
#include "contact/contactchecklistmodel.h"
#include "contact/contactmodel.h"
#include "contact/contactproxymodel.h"
#include "messagemodel.h"
// for view
#include "../view/chatstack.h"

#include <QStandardPaths>
#include <qqml.h>

ChatCore::ChatCore() { }

// contain declare

constexpr char ChatCore::QmlName[];

ChatMediator* ChatCore::media;
void ChatCore::init()
{

    // for linux
    auto path = QStandardPaths::writableLocation(QStandardPaths::AppConfigLocation) + "/chat";
    // auto path = QStandardPaths::writableLocation(QStandardPaths::AppConfigLocation);
    dc::Account::init(path);
    media = new ChatMediator();
    // @uri Dcchat
    qmlRegisterType<ChatProxyModel>(ChatCore::QmlName, 1, 0, "ChatProxyModel");
    qmlRegisterType<ChatListModel>(ChatCore::QmlName, 1, 0, "ChatListModel");
    qmlRegisterType<ChatRoomModel>(ChatCore::QmlName, 1, 0, "ChatRoomModel");
    qmlRegisterType<MessageModel>(ChatCore::QmlName, 1, 0, "MessageModel");
    qmlRegisterSingletonInstance(ChatCore::QmlName, 1, 0, "ChatMediator", media);
    qmlRegisterType<ChatContact>(ChatCore::QmlName, 1, 0, "ChatContact");
    qmlRegisterType<ChatStack>(ChatCore::QmlName, 1, 0, "ChatStack");

    qmlRegisterType<ContactProxyModel>(ChatCore::QmlName, 1, 0, "ContactProxyModel");
    qmlRegisterType<ContactModel>(ChatCore::QmlName, 1, 0, "ContactModel");
    qmlRegisterType<ContactCheckListModel>(ChatCore::QmlName, 1, 0, "ContactCheckListModel");
    qRegisterMetaType<QSize>();
    dc::Account::getInstance()->startEventLoop();
}

void ChatCore::close()
{

    dc::Account::close();
    delete media;
}

ChatMediator* ChatCore::getMediator()
{
    return media;
}
