#ifndef CHATLISTMODEL_H
#define CHATLISTMODEL_H

#include "chatcore.h"

#include <QAbstractListModel>
class ChatListModel : public QAbstractListModel {
    Q_OBJECT
    // read only proprety
    Q_PROPERTY(int status READ readStatus NOTIFY statusChanged FINAL)

public:
    enum ListRole {
        /** $chatid */
        ChatID = Qt::UserRole + 1,
        /** $name */
        Username, //
        /** count */
        Count
    };

private:
    QList<int> list;

    int m_status;

public:
    explicit ChatListModel(QObject* parent = nullptr);

signals:

    // QAbstractItemModel interface
public:
    int rowCount(const QModelIndex& parent) const;
    QHash<int, QByteArray> roleNames() const;
    QVariant data(const QModelIndex& index, int role) const;

    Q_INVOKABLE QString getName(const QVariant& index) const;

    // QAbstractItemModel interface
    int readStatus() const;

public slots:
    void onIncomingMessage(uint32_t accountId, int chatId, int msgId);
    void onDeleteChat(uint32_t accountId, int chatId);
    void onConnectyChange(uint32_t accountId, int status);
    void onMsgNotice(uint32_t accountId, int chatId);
    void onChatListItemChange(uint32_t accountId, int chatId);
signals:
    void updateView();
    void statusChanged();
};

#endif // CHATLISTMODEL_H
