#include "chatmediator.h"
#include "chatcore.h"
#include <QDebug>

ChatMediator::ChatMediator(QObject* parent)
    : QObject { parent }
{
}

void ChatMediator::setChatId(int id)
{
    chat_id = id;
}

uint32_t ChatMediator::getChatId()
{
    return chat_id;
}

void ChatMediator::createQrCode(uint32_t chat_id)
{
    auto ctx = dc::Account::getInstance()->getSelectedAccount();
    auto chat = ctx->getChat(chat_id);

    if (chat->getType() == DC_CHAT_TYPE_GROUP)
        qrCode = ctx->getSecurejoinQr(chat_id);
    else {
        qrCode = ctx->getSecurejoinQr(0);
    }
}

QString ChatMediator::getQrCode()
{
    return qrCode;
}

void ChatMediator::chatWithQrCode(const QString& qrcode)
{
    auto ctx = dc::Account::getInstance()->getSelectedAccount();
    ctx->joinSecurejoin(qrcode);
}

void ChatMediator::removeContact(int id)
{
    auto ctx = dc::Account::getInstance()->getSelectedAccount();
    ctx->deleteContact(id);
}

void ChatMediator::removeContactFromChat(int chat_id, int contact_id)
{
    auto ctx = dc::Account::getInstance()->getSelectedAccount();
    ctx->removeContactFromChat(chat_id, contact_id);
}
