#include "chatproxymodel.h"
#include "chatcore.h"
#include "chatlistmodel.h"
#include <QDebug>

ChatProxyModel::ChatProxyModel(QObject* parent)
    : QSortFilterProxyModel { parent }
{
}

void ChatProxyModel::setFilterString(const QString& filer)
{
    this->filter = filer;
    invalidateFilter();
}

bool ChatProxyModel::filterAcceptsRow(int source_row, const QModelIndex& source_parent) const
{

    const ChatListModel* model = static_cast<ChatListModel*>(sourceModel());
    auto index = createIndex(source_row, 0, nullptr);
    auto name = model->data(index, ChatListModel::Username).toString();
    if (filter != "") {
        qDebug() << "filer with name" << name;
        return name.contains(filter);
    }
    return true;
}

bool ChatProxyModel::lessThan(const QModelIndex& source_left, const QModelIndex& source_right) const
{

    // todo sort by arrival time
    // auto lid = model->data(source_left,ChatListModel::ListRole::ChatID).toInt();

    return source_left.row() > source_right.row();
}
