#ifndef CHATCONTACT_H
#define CHATCONTACT_H

#include <QAbstractListModel>

class ChatContact : public QAbstractListModel {
    Q_OBJECT

    Q_PROPERTY(int nuser READ getNuser NOTIFY nuserChanged FINAL)
    Q_PROPERTY(int chatId READ getChatId WRITE setChatId NOTIFY chatIdChanged FINAL)
    Q_PROPERTY(QString chatName READ getChatName NOTIFY chatNameChanged FINAL)
private:
    QList<uint32_t> m_contacts;

    enum ChatRole {
        Contact = Qt::UserRole,
        Id
    };

    int m_chatId = -1;

public:
    explicit ChatContact(QObject* parent = nullptr);

    // QAbstractItemModel interface
public:
    int rowCount(const QModelIndex& parent) const;
    QVariant data(const QModelIndex& index, int role) const;
    QHash<int, QByteArray> roleNames() const;

    int getNuser() const;

    Q_INVOKABLE void removeContact(int id);
    int getChatId() const;
    void setChatId(int newChatId);

    QString getChatName() const;

signals:
    void nuserChanged();
    void chatIdChanged();
    void chatNameChanged();
};

#endif // CHATCONTACT_H
