#ifndef CONTACTCHECKLISTMODEL_H
#define CONTACTCHECKLISTMODEL_H

#include <QAbstractListModel>
// show contact and ckecklist box
class ContactCheckListModel : public QAbstractListModel {
    Q_OBJECT
    Q_PROPERTY(int chatId READ getChatId WRITE setChatId NOTIFY chatIdChanged FINAL)
private:
    enum Role {
        Id = Qt::UserRole + 1,
        Name,
        Check

    };

    QList<int> contact_list;
    QList<bool> check_list;
    int m_id;

public:
    explicit ContactCheckListModel(QObject* parent = nullptr);

    // QAbstractItemModel interface
public:
    int rowCount(const QModelIndex& parent) const;
    QVariant data(const QModelIndex& index, int role) const;
    bool setData(const QModelIndex& index, const QVariant& value, int role = Role::Check);
    QHash<int, QByteArray> roleNames() const;

    Q_INVOKABLE void createChat(const QString& name, bool sercure = false);
    Q_INVOKABLE void addContactToChat(int id);
    Q_INVOKABLE int editRole();
    int getChatId() const;
    void setChatId(int newId);
signals:
    void chatIdChanged();
};

#endif // CONTACTCHECKLISTMODEL_H
