#include "contactmodel.h"
#include "contactproxymodel.h"
#include <memory>
ContactModel::ContactModel(QObject* par)
    : QAbstractListModel { par }
{
    id = -1;
    list = dc::Account::getInstance()->getSelectedAccount()->getContacts(0, "");
}

ContactModel::~ContactModel()
{
    m_contact = nullptr;
}

int ContactModel::rowCount(const QModelIndex& parent) const
{
    return list.size();
}

QVariant ContactModel::data(const QModelIndex& index, int role) const
{
    int row = index.row();
    if (row != id) {
        id = row;
        m_contact = dc::Account::getInstance()->getSelectedAccount()->getContact(list.at(id));
    }

    switch (role) {
    case ContactProxyModel::Role::Id:
        return list.at(id);
    case ContactProxyModel::Role::Name:
        return m_contact->getAddr();
    default:
        break;
    }
    return "";
}

QHash<int, QByteArray> ContactModel::roleNames() const
{
    QHash<int, QByteArray> rl;
    rl[ContactProxyModel::Role::Id] = "$id";
    rl[ContactProxyModel::Role::Name] = "$name";
    return rl;
}

int ContactModel::chatWithId(int id)
{
    auto ctx = dc::Account::getInstance()->getSelectedAccount();
    int res = ctx->createChatByContactId(id);
    return res;
}

int ContactModel::newChatWithEmail(const QString& mail)
{
    // todo check email vaild
    auto ctx = dc::Account::getInstance()->getSelectedAccount();
    auto contact = ctx->createContact(mail, mail);
    int res = ctx->createChatByContactId(contact);
    return contact;
}
