#ifndef CONTACTMODEL_H
#define CONTACTMODEL_H

#include "../chatcore.h"
#include <QAbstractListModel>

class ContactModel : public QAbstractListModel {
    Q_OBJECT
protected:
    mutable int id;
    mutable std::shared_ptr<dc::Contact> m_contact;

    QList<int> list;

public:
    ContactModel(QObject* parent = nullptr);
    ~ContactModel();
    // QAbstractItemModel interface
public:
    int rowCount(const QModelIndex& parent) const;
    QVariant data(const QModelIndex& index, int role) const;
    QHash<int, QByteArray> roleNames() const;
    Q_INVOKABLE int chatWithId(int id);
    Q_INVOKABLE int newChatWithEmail(const QString& mail);
};

#endif // CONTACTMODEL_H
