#include "contactproxymodel.h"

ContactProxyModel::ContactProxyModel(QObject* par)
    : QSortFilterProxyModel { par }
{
}

QString ContactProxyModel::getContact() const
{
    return m_contact;
}

void ContactProxyModel::setContact(const QString& newContact)
{
    if (m_contact == newContact)
        return;
    m_contact = newContact;
    emit contactChanged();
    invalidateFilter();
}

bool ContactProxyModel::filterAcceptsRow(int source_row, const QModelIndex& source_parent) const
{
    auto model = sourceModel();
    auto addr = model->data(this->index(source_row, 0), Role::Name).toString();
    return addr.contains(m_contact);
}
