#ifndef CONTACTPROXYMODEL_H
#define CONTACTPROXYMODEL_H

#include <QSortFilterProxyModel>

class ContactProxyModel : public QSortFilterProxyModel {
    Q_OBJECT
    Q_PROPERTY(QString contact READ getContact WRITE setContact NOTIFY contactChanged FINAL)
public:
    enum Role {
        Id = Qt::UserRole + 1,
        Name
    };

public:
    ContactProxyModel(QObject* parent = nullptr);
    ~ContactProxyModel() {};
    // QSortFilterProxyModel interface
    QString getContact() const;
    void setContact(const QString& newContact);

signals:
    void contactChanged();

protected:
    bool filterAcceptsRow(int source_row, const QModelIndex& source_parent) const;

private:
    QString m_contact;
};

#endif // CONTACTPROXYMODEL_H
