#ifndef MESSAGEMODEL_H
#define MESSAGEMODEL_H

#include <QDateTime>
#include <QObject>
class MessageModel : public QObject {
    Q_OBJECT

    Q_PROPERTY(int chatId READ getChatId WRITE setChatId NOTIFY chatIdChanged FINAL)
public:
    explicit MessageModel(QObject* parent = nullptr);
    ~MessageModel();

    Q_INVOKABLE void sendText(const QString& Text);
    int getChatId() const;
    void setChatId(int newChatId);

signals:

    void chatIdChanged();

private:
    int m_chatId = -1;
};

Q_DECLARE_METATYPE(MessageModel*);
#endif // MESSAGEMODEL_H
