#include "chatstack.h"
#include <QDebug>
ChatStack::ChatStack(QObject* par)
    : QObject { par }
{
}

ChatStack::~ChatStack()
{
    map.clear();
    stack.clear();
}

void ChatStack::pushView(const QString& url)
{
    if (!url.isEmpty())
        stack.append(url);
}

QString ChatStack::popView()
{
    if (stack.size() > 0) {
        auto ret = stack.last();
        stack.removeLast();
        return ret;
    } else
        return "";
}

void ChatStack::clearStackView()
{
    stack.clear();
}

void ChatStack::pushMap(const QString& key, const QVariant& data)
{
    map[key] = data;
}

QVariant ChatStack::popMap(const QString& key)
{
    auto data = map[key];
    map.remove(key);
    return data;
}
